drama.shaders = {};
drama.shaders["setcolor"] = {
	src: "varying mediump vec2 vTex;\nuniform lowp sampler2D samplerFront;\nuniform lowp vec3 setColor;\n\nvoid main(void)\n{\n	lowp float a = texture2D(samplerFront, vTex).a;\n	\n	gl_FragColor = vec4(setColor.r * a, setColor.g * a, setColor.b * a, a);\n}\n",
	extendBoxHorizontal: 0,
	extendBoxVertical: 0,
	crossSampling: false,
	preservesOpaqueness: true,
	animated: false,
	parameters: [["setColor",0,2]]
};

drama.shaders["water"] = {
	src: "varying mediump vec2 vTex;\nuniform lowp sampler2D samplerFront;\nuniform mediump vec2 srcStart;\nuniform mediump vec2 srcEnd;\n\nprecision mediump float;\nuniform float seconds;\nuniform mediump vec2 pixelSize;\n\nconst float PI = 3.1415926535897932;uniform float speed;\nuniform float speed_x;\nuniform float speed_y;uniform float intensity;\nconst float steps = 8.0;\nuniform float frequency;\nuniform float angle;uniform float delta;\nuniform float intence;\nuniform float emboss;\n\nfloat col(vec2 coord)\n{\n	float delta_theta = 2.0 * PI / angle;\n	float col = 0.0;\n	float theta = 0.0;\n	for (float i = 0.0; i < steps; i++)\n	{\n		vec2 adjc = coord;\n		theta = delta_theta*i;\n		adjc.x += cos(theta)*seconds*speed + seconds * speed_x;\n		adjc.y -= sin(theta)*seconds*speed - seconds * speed_y;\n		col = col + cos( (adjc.x*cos(theta) - adjc.y*sin(theta))*frequency)*intensity;\n	}\n\n	return cos(col);\n}\n\nvoid main(void)\n{\n	mediump vec2 tex = (vTex - srcStart) / (srcEnd - srcStart);\n	\n	vec2 p = tex, c1 = p, c2 = p;\n	float cc1 = col(c1);\n\n	c2.x += (1.0 / pixelSize.x) / delta;\n	float dx = emboss*(cc1-col(c2))/delta;\n\n	c2.x = p.x;\n	c2.y += (1.0 / pixelSize.y) / delta;\n	float dy = emboss*(cc1-col(c2))/delta;\n\n	c1.x += dx;\n	c1.y = -(c1.y+dy);\n\n	float alpha = 1.+dot(dx,dy)*intence;\n	c1.y = -c1.y;\n	c1 = clamp(c1, 0.0, 1.0);\n	gl_FragColor = texture2D(samplerFront, mix(srcStart, srcEnd, c1)) * alpha;\n}\n",
	extendBoxHorizontal: 40,
	extendBoxVertical: 40,
	crossSampling: false,
	preservesOpaqueness: false,
	animated: true,
	parameters: [["speed",0,1],["speed_x",0,1],["speed_y",0,1],["intensity",0,0],["frequency",0,0],["angle",0,0],["delta",0,0],["intence",0,0],["emboss",0,1]]
};
